//!definitions.h

/*
    This header contains all of the hardware definitions of the board 
 */


#define TRUE  1
#define FALSE 0

#define ON    0
#define OFF   1

/* IIC definitions */
#define I2C_HW              //comentar si se quiere usar I2C por software
#define RST LATDbits.LATD11 //RST del LCD para la inicializacon

#define SCL LATDbits.LATD10
#define SDA LATDbits.LATD9
#define SCL_TRIS TRISDbits.TRISD10
#define SDA_TRIS TRISDbits.TRISD9
#define RST_TRIS TRISDbits.TRISD11
#define SDA_READ PORTDbits.RD9
//end of IIC definitions

/* UART definitions */
#define UART_COM_RXD_TRIS TRISBbits.TRISB8
#define UART_COM_TXD_TRIS TRISBbits.TRISB9

#define STX     2			//start transmission
#define ETX     13

#define RELAY   0x0A		//<-| 
#define OCOUT	0x0B		//<-|
#define LEDPT	0x0C		//<-|
#define BUZZ	0x0E		//<-|---- MODULES
#define OII	0x1A		//<-|
#define DIPSW	0x1B		//<-|
#define PT10K	0x1C 		//<-/

/*  input definitions */



//opto isolated inputs
#define OPTO1   PORTBbits.RB0
#define OPTO2   PORTBbits.RB1
#define OPTO3   PORTBbits.RB2
#define OPTO4   PORTBbits.RB3

//on board switches & DIP sw
#define SW1 	PORTBbits.RB13
#define SW2	PORTBbits.RB12
#define SW3	PORTBbits.RB11
#define SW4	PORTBbits.RB10

#define DIP1_5	PORTBbits.RB10
#define DIP2_6	PORTBbits.RB11
#define DIP3_7	PORTBbits.RB12
#define DIP4_8	PORTBbits.RB13

#define DSWLSBE LATFbits.LATF1 
#define DSWMSBE LATFbits.LATF0

#define DMSB    0       //enables the MSB bits for the DIP SW
#define DLSB    1       //enables the LSB bits for the DIP SW
#define DDIS    2       //disables DIP SW both MSB & LSB nibbles

/* LCD*/
#define BLI4 800        //highest intensity
#define BLI3 1600	//..
#define BLI2 2400	//..
#define BLI1 3040       //lowest intensity
//end of input definitions

/* output definitions */
#define RLY1 LATDbits.LATD7
#define RLY2 LATDbits.LATD6
#define RLY3 LATDbits.LATD5
#define RLY4 LATDbits.LATD4

#define OC1  LATDbits.LATD3
#define OC2  LATDbits.LATD2
#define OC3  LATDbits.LATD1
#define OC4  LATDbits.LATD0

#define LED1 LATEbits.LATE0
#define LED2 LATEbits.LATE1
#define LED3 LATEbits.LATE2
#define LED4 LATEbits.LATE3
#define LED5 LATEbits.LATE4
#define LED6 LATEbits.LATE5
#define LED7 LATEbits.LATE6
#define LED8 LATEbits.LATE7

#define BUZZER LATGbits.LATG7


//end of output definitions

