#include <p24FJ128GB106.h>
#include "GenericTypeDefs.h"    //for BOOL

#define USE_AND_OR  
#define ocmp_v2_3
#include "outcompare.h"
#include "GenericTypeDefs.h"
#include "definitions.h"
#include "outputs.h"

//usado para normalizar de periodo en uS al valor del registro de conteo del PWM
#define PWM_CONV_FACTOR 8



void LEDport(unsigned char lednum, char state)
{
    switch(lednum)
    {
        case 1:
            if(state){	LED1 = 1;}	//lo apaga
            else     {	LED1 = 0;}	//lo prende
            break;
        case 2:
            if(state){	LED2 = 1;}
            else     {	LED2 = 0;}
            break;
        case 3:
            if(state){	LED3 = 1;}
            else     {	LED3 = 0;}
            break;
        case 4:
            if(state){	LED4 = 1;}
            else     {	LED4 = 0;}
            break;
        case 5:
            if(state){	LED5 = 1;}
            else     {	LED5 = 0;}
            break;
        case 6:
            if(state){  LED6 = 1;}
            else     {	LED6 = 0;}
            break;
        case 7:
            if(state){	LED7 = 1;}
            else     {	LED7 = 0;}
            break;
        case 8:
            if(state){	LED8 = 1;}
            else     {	LED8 = 0;}
            break;
    }
}

void RLYport(unsigned char rlynum, char state)
{
    switch(rlynum)
    {
        case 1:
            if(state){  RLY1 = 0;}	//lo prende
            else     {  RLY1 = 1;}    //lo apaga
            break;
        case 2:
            if(state){  RLY2 = 0;}
            else     {  RLY2 = 1;}
            break;
        case 3:
            if(state){  RLY3 = 0;}
            else     {  RLY3 = 1;}
            break;
        case 4:
            if(state){  RLY4 = 0;}
            else     {  RLY4 = 1;}
            break;
    }
}

void OCport(unsigned char ocnum, char state)
{
    switch(ocnum)
    {
        case 1:
            if(state){  OC1 = 0;}	//lo prende
            else     {  OC1 = 1;}	//lo apaga
            break;
        case 2:
            if(state){  OC2 = 0;}
            else     {  OC2 = 1;}
            break;
        case 3:
            if(state){  OC3 = 0;}
            else     {  OC3 = 1;}
            break;
        case 4:
            if(state){  OC4 = 0;}
            else     {  OC4 = 1;}
            break;
    }
}


//recibe el periodo en micro segundos (uS) y duty cycle (50, 75)
void buzzer(unsigned int period_uS, unsigned int duty_div)
{
    UINT32 duty = 0;
    unsigned int fixed_period = 0;

    if(period_uS < 8000){   //rango del registro 65535
        fixed_period = (period_uS * PWM_CONV_FACTOR);
    }else{
        fixed_period = 1000;
    }
	    	
    CloseOC2();
    if(duty_div && fixed_period){
        duty  = fixed_period;
        duty *= duty_div;
        duty /= 100;
        OpenOC2(OC_SYSCLK_SRC  | OC_CONTINUE_PULSE, OC_SYNC_TRIG_IN_CURR_OC, fixed_period, duty);
    }
}

void backlight(unsigned int value)
{
    CloseOC1();
    if(value){
        OpenOC1(OC_SYSCLK_SRC  | OC_CONTINUE_PULSE, OC_SYNC_TRIG_IN_CURR_OC, 3200, value);
    }
}













