#include <p24FJ128GB106.h>
#include "string.h"         //para memset
#include "serial.h"         //prototipos de las funciones
#include <uart.h>           //funciones de Microchip
#include "definitions.h"    //definiciones globales


unsigned char RX_data = 0;
unsigned char BufferIndex  = 0;
unsigned char cmdBuffer[20];
unsigned char MessageLength = 0;

/**************************************************************************/

void rx_int(void)                               //interrupcion de recepcion
{
    RX_data = ReadUART2();                      //leer el buffer de recepcion

    switch(RX_data){
        case STX:                               //inicio
            BufferIndex = 0;
            MessageLength = 0;
            memset(cmdBuffer, 0, 20);
            break;
        case ETX:                               //fin
            MessageLength = BufferIndex;
            break;
        default:                                //guardar en el buffer
            cmdBuffer[BufferIndex] = RX_data;
            RX_data = 0;
            BufferIndex++;
            break;
    }
}

void tx_int(void)                 	// Interrupcion de Transmision
{
    //no implementada
}

void __attribute__ ((interrupt,no_auto_psv)) _U2TXInterrupt(void)
{	
    tx_int();
    U2TX_Clear_Intr_Status_Bit;  //clear the interrupt status of UART2 TX
}


void __attribute__ ((interrupt,no_auto_psv)) _U2RXInterrupt(void)
{
    rx_int();
    U2RX_Clear_Intr_Status_Bit;  //clear the interrupt status of UART2 RX     
}

void initUARTcommunication(void)
{
    CloseUART2();  		//deshabilitar UART

    //low baudrate, 8bit comm, no parity, 1 stop bit
    IFS1bits.U2RXIF  = 0;
    IEC1bits.U2RXIE  = 1;       //habilitar interrupcion de recepcion
    IPC7bits.U2RXIP2 = 0;
    IPC7bits.U2RXIP1 = 1;
    IPC7bits.U2RXIP0 = 0;

    U2MODE = 0x8000;

    U2STA  = 0x2400;
    U2BRG  = BAUD19200;         //serial.h
}

void RS232_put(unsigned int data)   //escribe datos al protocolo
{
    WriteUART2(data);
}
