/*
	Este header contiene todas las funciones
	que se usan para probar el Aguijon en 
	Test mode desde una computadora.
 *
 * Estructura del comando:
 * 02 0A A1 01 0D   prende el RLY 1
 * STX MODULO MIEMBRO ESTADO ETX (definitions.h)
*/

#include "serial.h"


#include <p24FJ128GB106.h>
#include <uart.h>
#include "definitions.h"
#include "tester.h"
#include "outputs.h"
#include "inputs.h"
#include "outcompare.h"

extern unsigned char cmdBuffer[3];

void RLY_serial(void)
{
    switch(cmdBuffer[1]){
        case 0xA1:
            if(cmdBuffer[2]){	RLYport(1,ON);	}
            else{		RLYport(1,OFF);	}
            break;
        case 0xA2:
            if(cmdBuffer[2]){	RLYport(2,ON);	}
            else{		RLYport(2,OFF);	}
            break;
        case 0xA3:
            if(cmdBuffer[2]){	RLYport(3,ON);	}
            else{		RLYport(3,OFF);	}
            break;
        case 0xA4:
            if(cmdBuffer[2]){	RLYport(4,ON);	}
            else{		RLYport(4,OFF);	}
            break;
    }
    RS232_put(0xFF);
}

void OC_serial(void)
{
    switch(cmdBuffer[1]){
        case 0xB1:
            if(cmdBuffer[2]){	OCport(1,ON);	}
            else{		OCport(1,OFF);	}
            break;
        case 0xB2:
            if(cmdBuffer[2]){	OCport(2,ON);	}
            else{		OCport(2,OFF);	}
            break;
        case 0xB3:
            if(cmdBuffer[2]){	OCport(3,ON);	}
            else{		OCport(3,OFF);	}
            break;
        case 0xB4:
            if(cmdBuffer[2]){	OCport(4,ON);	}
            else{		OCport(4,OFF);	}
            break;
    }
    RS232_put(0xFF);
}

void LEDPort_serial(void)
{
    switch(cmdBuffer[1]){
        case 0xC1:
            if(cmdBuffer[2]){	LEDport(1,ON);	}
            else{		LEDport(1,OFF);	}
            break;
        case 0xC2:
            if(cmdBuffer[2]){	LEDport(2,ON);	}
            else{		LEDport(2,OFF);	}
            break;
        case 0xC3:
            if(cmdBuffer[2]){	LEDport(3,ON);	}
            else{		LEDport(3,OFF);	}
            break;
        case 0xC4:
            if(cmdBuffer[2]){	LEDport(4,ON);	}
            else{		LEDport(4,OFF);	}
            break;
        case 0xC5:
            if(cmdBuffer[2]){	LEDport(5,ON);	}
            else{		LEDport(5,OFF);	}
            break;
        case 0xC6:
            if(cmdBuffer[2]){	LEDport(6,ON);	}
            else{		LEDport(6,OFF);	}
            break;
        case 0xC7:
            if(cmdBuffer[2]){	LEDport(7,ON);	}
            else{		LEDport(7,OFF);	}
            break;
        case 0xC8:
            if(cmdBuffer[2]){	LEDport(8,ON);	}
            else{		LEDport(8,OFF);	}
            break;
    }
    RS232_put(0xFF);
}
